## polybar 3.5.5

=== CMakeLists.txt ===
#
# Build configuration
#
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)

# Enable ccache by default and as early as possible because project() performs
# checks on the compiler
option(ENABLE_CCACHE "Enable ccache support" ON)
if(ENABLE_CCACHE)
  message(STATUS "Trying to enable ccache")
  find_program(BIN_CCACHE ccache)

  string(ASCII 27 esc)
  if(NOT BIN_CCACHE)
    message(STATUS "${esc}[33mCouldn't locate ccache, disabling ccache...${esc}[0m")
  else()
    # Enable only if the binary is found
    message(STATUS "${esc}[32mUsing compiler cache ${BIN_CCACHE}${esc}[0m")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${BIN_CCACHE})
  endif()
endif()

project(polybar CXX)

# Extract version information from version.txt. The first line that looks like
# a version string is used, so the file supports comments
file(STRINGS version.txt version_txt REGEX "^[0-9]+\\.[0-9]+\\.[0-9]+.*$" LIMIT_COUNT 1)

# If we are in a git repo we can get the version information from git describe
execute_process(COMMAND git describe --tags --dirty=-dev
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  RESULT_VARIABLE git_result
  OUTPUT_VARIABLE git_describe
  OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_QUIET)

if(git_result EQUAL "0")
  set(APP_VERSION "${git_describe}")
else()
  message(STATUS "Could not detect version with git, falling back to built-in version information.")
  set(APP_VERSION "${version_txt}")
endif()

set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/common
  ${PROJECT_SOURCE_DIR}/cmake/modules)

include(GNUInstallDirs)
include(utils)
include(01-core)
include(02-opts)
include(03-libs)
include(04-targets)
include(05-summary)

if(BUILD_DOC)
  add_subdirectory(doc)
endif()
add_subdirectory(contrib/bash)
add_subdirectory(contrib/zsh)
add_subdirectory(include)
add_subdirectory(lib)
add_subdirectory(src bin)

# We need to enable testing in the root folder so that 'ctest' and 'make test'
# can be run in the build directory
if(BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()


#
# Generate configuration file
#

set(MODULES_LEFT "bspwm i3")
set(MODULES_CENTER "mpd")
set(MODULES_RIGHT "filesystem xbacklight alsa pulseaudio xkeyboard memory cpu wlan eth battery temperature date powermenu")

set(FONT_FIXED "fixed:pixelsize=10")
set(FONT_UNIFONT "unifont:fontformat=truetype")
set(FONT_SIJI "siji:pixelsize=10")

queryfont(FONT_FIXED ${FONT_FIXED} FIELDS family pixelsize)
queryfont(FONT_UNIFONT ${FONT_UNIFONT} FIELDS family fontformat)
queryfont(FONT_SIJI ${FONT_SIJI} FIELDS family pixelsize)

# Strip disabled modules {{{

if(NOT ENABLE_PULSEAUDIO)
  string(REPLACE " pulseaudio" "" MODULES_RIGHT ${MODULES_RIGHT})
endif()
if(NOT ENABLE_ALSA)
  string(REPLACE " alsa" "" MODULES_RIGHT ${MODULES_RIGHT})
endif()
if(NOT ENABLE_I3)
  string(REPLACE " i3" "" MODULES_LEFT ${MODULES_LEFT})
endif()
if(NOT ENABLE_MPD)
  string(REPLACE "mpd" "" MODULES_CENTER ${MODULES_CENTER})
endif()
if(NOT ENABLE_NETWORK)
  string(REPLACE " wlan eth" "" MODULES_RIGHT ${MODULES_RIGHT})
endif()
if(NOT WITH_XRANDR)
  string(REPLACE "xbacklight " "backlight-acpi " MODULES_RIGHT ${MODULES_RIGHT})
endif()
if(NOT WITH_XKB)
  string(REPLACE "xkeyboard " "" MODULES_RIGHT ${MODULES_RIGHT})
endif()

# }}}
# Get battery/adapter name {{{

string(REGEX REPLACE /%battery%.* "" PATH_BAT ${SETTING_PATH_BATTERY})
string(REGEX REPLACE /%adapter%.* "" PATH_ADP ${SETTING_PATH_ADAPTER})
file(GLOB BAT_LIST RELATIVE ${PATH_BAT} ${PATH_ADP}/B*)
file(GLOB ADP_LIST RELATIVE ${PATH_ADP} ${PATH_ADP}/A*)
if(BAT_LIST)
  list(GET BAT_LIST 0 BATTERY)
else()
  set(BATTERY BAT0)
endif()
if(ADP_LIST)
  list(GET ADP_LIST 0 ADAPTER)
else()
  set(ADAPTER ADP1)
endif()

# }}}
# Get network interfaces {{{

if(ENABLE_NETWORK)
  file(GLOB IFLIST RELATIVE /sys/class/net /sys/class/net/*)
  foreach(INTERFACE ${IFLIST})
    if(NOT ${INTERFACE} STREQUAL "lo")
      file(GLOB IS_WIRELESS /sys/class/net/${INTERFACE}/wireless)
      if(IS_WIRELESS)
        set(INTERFACE_WLAN ${INTERFACE})
      else()
        set(INTERFACE_ETH ${INTERFACE})
      endif()
    endif()
  endforeach()
  if(NOT INTERFACE_ETH)
    set(INTERFACE_ETH net0)
  endif()
  if(NOT INTERFACE_WLAN)
    set(INTERFACE_WLAN net1)
  endif()
endif()

# }}}
# Configure and install {{{

configure_file(
  ${CMAKE_CURRENT_LIST_DIR}/config.cmake
  ${CMAKE_CURRENT_LIST_DIR}/config
  ESCAPE_QUOTES @ONLY)

install(FILES config
  DESTINATION ${CMAKE_INSTALL_DOCDIR}
  COMPONENT config)

# }}}

=== include/CMakeLists.txt ===
#
# Generate settings.hpp
#

list(APPEND dirs ${CMAKE_CURRENT_LIST_DIR})

if(WITH_XRANDR)
  list(APPEND XPP_EXTENSION_LIST xpp::randr::extension)
endif()
if(WITH_XCOMPOSITE)
  list(APPEND XPP_EXTENSION_LIST xpp::composite::extension)
endif()
if(WITH_XKB)
  list(APPEND XPP_EXTENSION_LIST xpp::xkb::extension)
endif()
string(REPLACE ";" ", " XPP_EXTENSION_LIST "${XPP_EXTENSION_LIST}")

configure_file(
  ${CMAKE_CURRENT_LIST_DIR}/settings.hpp.cmake
  ${CMAKE_BINARY_DIR}/generated-sources/settings.hpp
  ESCAPE_QUOTES)

list(APPEND dirs ${CMAKE_BINARY_DIR}/generated-sources/)
set(APP_VERSION ${APP_VERSION} PARENT_SCOPE)
set(dirs ${dirs} PARENT_SCOPE)

=== lib/CMakeLists.txt ===
#
# Configure libs
#

# Library: concurrentqueue {{{

add_library(concurrentqueue INTERFACE)
target_include_directories(concurrentqueue INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/concurrentqueue/include>)
list(APPEND libs concurrentqueue)

# }}}
# Library: xpp {{{

set(XCB_PROTOS xproto)

if(WITH_XRANDR)
  list(APPEND XCB_PROTOS randr)
endif()
if(WITH_XCOMPOSITE)
  list(APPEND XCB_PROTOS composite)
endif()
if(WITH_XKB)
  list(APPEND XCB_PROTOS xkb)
endif()

add_subdirectory(xpp)
list(APPEND libs xpp)

# }}}
# Library: i3ipcpp {{{

if(ENABLE_I3)
  add_subdirectory(i3ipcpp)
  list(APPEND libs ${I3IPCPP_LIBRARIES})
endif()

# }}}

set(libs ${libs} PARENT_SCOPE)

=== contrib/zsh/CMakeLists.txt ===
#
# Zsh completion template
#
install(FILES _polybar _polybar_msg
  DESTINATION ${CMAKE_INSTALL_DATADIR}/zsh/site-functions
  COMPONENT tools)

=== lib/xpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
project(xpp)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

#
# Process dependencies
#
find_package(PkgConfig)
pkg_check_modules(XCBPROTO REQUIRED xcb-proto)

# Store the location of the proto xml files inside XCBPROTO_XCBINCLUDEDIR
if(${CMAKE_VERSION} VERSION_LESS "3.4.0")
    # pkg_get_variable was introduced in 3.4.0 if it isn't available, we fall back to ${prefix}/share/xcb

    if(NOT XCBPROTO_PREFIX)
        set(XCBPROTO_PREFIX /usr)
    endif()

    set(XCBPROTO_XCBINCLUDEDIR ${XCBPROTO_PREFIX}/share/xcb)
    message(STATUS "${PROJECT_NAME}: pkg_get_variable not supported, setting XCBPROTO_XCBINCLUDEDIR to ${XCBPROTO_XCBINCLUDEDIR}")
else()
    # The xml file that need to be included later are stored in xcbincludedir as defined in xcb-proto.pc
    pkg_get_variable(XCBPROTO_XCBINCLUDEDIR xcb-proto xcbincludedir)
endif()

find_package(PythonInterp 3.5 REQUIRED)
find_package(XCB REQUIRED XCB ICCCM EWMH UTIL IMAGE)

if(NOT PYTHON_EXECUTABLE)
  message(FATAL_ERROR "Missing PYTHON_EXECUTABLE")
endif()

set(GEN_SRC "${CMAKE_CURRENT_BINARY_DIR}/generated-sources")

set(XPP_INCLUDE_DIRS
  ${PROJECT_SOURCE_DIR}/include
  ${GEN_SRC}/include
  ${XCB_XCB_INCLUDE_DIR}
  ${XCB_EWMH_INCLUDE_DIR}
  ${XCB_ICCCM_INCLUDE_DIR}
  ${XCB_UTIL_INCLUDE_DIR}
  ${XCB_IMAGE_INCLUDE_DIR})
set(XPP_LIBRARIES
  ${XCB_XCB_LIBRARY}
  ${XCB_EWMH_LIBRARY}
  ${XCB_ICCCM_LIBRARY}
  ${XCB_UTIL_LIBRARY}
  ${XCB_IMAGE_LIBRARY})

#
# Loop through a hardcoded list of python executables to locate the python module "xcbgen"
#
# TODO drop python2 once ubuntu and debian ship python3-xcbgen in their
# maintained distros
foreach(CURRENT_EXECUTABLE ${PYTHON_EXECUTABLE} python3 python python2 python2.7)
  message(STATUS "Searching for xcbgen with " ${CURRENT_EXECUTABLE})

  execute_process(COMMAND "${CURRENT_EXECUTABLE}" "-c"
    "import re,xcbgen;print(re.compile('/xcbgen/__init__.py.*').sub('',xcbgen.__file__))"
    RESULT_VARIABLE _xcbgen_status
    OUTPUT_VARIABLE _xcbgen_location
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

  # When a shell script returns successfully its return code is 0
  if(_xcbgen_status EQUAL 0)
    set(PYTHON_XCBGEN "${_xcbgen_location}" CACHE STRING "Location of python module: xcbgen ")
    message(STATUS "Found xcbgen in " ${PYTHON_XCBGEN})
    break()
  endif()

endforeach(CURRENT_EXECUTABLE)

if(NOT PYTHON_XCBGEN)
  message(FATAL_ERROR "Missing required python module: xcbgen")
endif()

#
# Include XCB libs depending on what protos we build
#
if(NOT XCB_PROTOS)
  set(XCB_PROTOS
    "bigreq"
    "composite"
    "damage"
    "dpms"
    "dri2"
    "dri3"
    "glx"
    "present"
    "randr"
    "record"
    "render"
    "res"
    "screensaver"
    "shape"
    "shm"
    "sync"
    "xc_misc"
    "xevie"
    "xf86dri"
    "xfixes"
    "xinerama"
    "xinput"
    "xkb"
    "xprint"
    "xproto"
    "xselinux"
    "xtest"
    "xv"
    "xvmc")
endif()

if(";${XCB_PROTOS};" MATCHES ";randr;")
  find_package(XCB REQUIRED RANDR)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_RANDR_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_RANDR_LIBRARY})
endif()
if(";${XCB_PROTOS};" MATCHES ";render;")
  find_package(XCB REQUIRED RENDER)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_RENDER_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_RENDER_LIBRARY})
endif()
if(";${XCB_PROTOS};" MATCHES ";damage;")
  find_package(XCB REQUIRED DAMAGE)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_DAMAGE_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_DAMAGE_LIBRARY})
endif()
if(";${XCB_PROTOS};" MATCHES ";sync;")
  find_package(XCB REQUIRED SYNC)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_SYNC_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_SYNC_LIBRARY})
endif()
if(";${XCB_PROTOS};" MATCHES ";composite;")
  find_package(XCB REQUIRED COMPOSITE)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_COMPOSITE_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_COMPOSITE_LIBRARY})
endif()
if(";${XCB_PROTOS};" MATCHES ";xkb;")
  find_package(XCB REQUIRED XKB)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_XKB_INCLUDE_DIR})
  set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_XKB_LIBRARY})
endif()

set(PROTO_LIST)

file(GLOB PROTO_LIST_RAW RELATIVE ${XCBPROTO_XCBINCLUDEDIR} ${XCBPROTO_XCBINCLUDEDIR}/*.xml)

#
# Filter glob
#
foreach(PROTO_RAW ${PROTO_LIST_RAW})
  string(REGEX REPLACE "(^xf86vidmode.xml|^ge.xml|.xml)\$" "" PROTO ${PROTO_RAW})
  if(PROTO AND ";${XCB_PROTOS};" MATCHES ";${PROTO};")
    message(STATUS "${PROJECT_NAME}: including xcb proto ${PROTO_RAW}")
    set(PROTO_LIST ${PROTO_LIST} ${PROTO})
  endif()
endforeach(PROTO_RAW)

#
# Add commands
#
set(PROTO_HEADER_DIR "${GEN_SRC}/include/xpp/proto")
file(MAKE_DIRECTORY ${PROTO_HEADER_DIR})
set(PROTO_HEADER_FILES "")
foreach(PROTO ${PROTO_LIST})
  string(REGEX REPLACE "proto\$" "" PROTO_OUTPUT ${PROTO})
  set(OUTPUT_FILE ${PROTO_HEADER_DIR}/${PROTO_OUTPUT}.hpp)
  add_custom_command(
    OUTPUT ${OUTPUT_FILE}
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/generators/cpp_client.py -p "${PYTHON_XCBGEN}"
    ${XCBPROTO_XCBINCLUDEDIR}/${PROTO}.xml > ${OUTPUT_FILE})
  list(APPEND PROTO_HEADER_FILES ${OUTPUT_FILE})
endforeach(PROTO)

#
# Create project lib and commands
#
file(GLOB_RECURSE HEADER_FILES ${PROJECT_SOURCE_DIR}/include/*.hpp)
add_library(${PROJECT_NAME} STATIC ${HEADER_FILES} ${PROTO_HEADER_FILES})

target_include_directories(${PROJECT_NAME} PUBLIC ${XPP_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PRIVATE ${XPP_LIBRARIES})

target_compile_options(${PROJECT_NAME} PRIVATE -std=c++14 -Wall -Wpedantic)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Debug>:-g3 -DDEBUG>)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Release>:-O3 -Wno-unused-variable>)
target_compile_options(${PROJECT_NAME} PUBLIC ${X11_XCB_DEFINITIONS} ${XCB_DEFINITIONS})

set_target_properties(${PROJECT_NAME} PROPERTIES LINKER_LANGUAGE CXX)

#
# Export lists to the parent scope if there are any
#
get_directory_property(HAS_PARENT PARENT_DIRECTORY)

if(HAS_PARENT)
  set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} PARENT_SCOPE)
  set(XPP_LIBRARIES ${PROJECT_NAME} PARENT_SCOPE)
endif()

=== lib/xpp/src/examples/Makefile ===
include ../../include/flags.makefile

CXXFLAGS+=-g
CXXFLAGS+=-Wextra

CPPSRCS=$(shell find . -name '*.cpp')
EXAMPLES=${CPPSRCS:./%.cpp=%}

all: ${EXAMPLES}

clean:
	rm -f ${EXAMPLES}

.PHONY: clean

=== debian/changelog ===
polybar (3.5.5-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Revert to dh-compat=12.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 21 Mar 2021 08:43:39 -0700

polybar (3.5.5-1) unstable; urgency=medium

  * New upstream version 3.5.5

 -- Utkarsh Gupta <utkarsh@debian.org>  Tue, 02 Mar 2021 02:52:57 +0530

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath

ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mips mipsel sh4))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure --		   \
	  -DBUILD_DOC:BOOL="ON"            \
	  -DBUILD_TESTS:BOOL="OFF"          \
	  -DENABLE_ALSA:BOOL="ON"          \
	  -DENABLE_PULSEAUDIO:BOOL="ON"    \
	  -DENABLE_I3:BOOL="ON"            \
	  -DENABLE_MPD:BOOL="ON"           \
	  -DENABLE_NETWORK:BOOL="ON"       \
	  -DENABLE_CURL:BOOL="ON"          \
	  -DBUILD_IPC_MSG:BOOL="ON"

override_dh_compress:
	dh_compress --exclude=config

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## polybar 3.5.6

=== debian/changelog ===
polybar (3.5.6-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 14 Jun 2021 13:59:13 -0700

=== debian/control ===
Source: polybar
Section: x11
Priority: optional
Homepage: https://polybar.github.io/
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Samuel Henrique <samueloph@debian.org>
Uploaders: Utkarsh Gupta <utkarsh@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               i3-wm,
               libasound2-dev,
               libcairo2-dev,
               libcurl4-openssl-dev,
               libjsoncpp-dev,
               libmpdclient-dev,
               libnl-genl-3-dev,
               libpulse-dev,
               libxcb-composite0-dev,
               libxcb-cursor-dev,
               libxcb-damage0-dev,
               libxcb-ewmh-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-randr0-dev,
               libxcb-render0-dev,
               libxcb-sync-dev,
               libxcb-util0-dev,
               libxcb-xkb-dev,
               libxcb-xrm-dev,
               pkg-config,
               python3-sphinx,
               python3-xcbgen,
               xcb-proto
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/polybar
Vcs-Git: https://salsa.debian.org/debian/polybar.git

Package: polybar
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast and easy-to-use tool for creating status bars
 Polybar aims to help users build beautiful and highly customizable status bars
 for their desktop environment, without the need of having a black belt in
 shell scripting.

## polybar 3.5.7

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)

# Only used if documentation is built on its own
project(polybar-doc NONE)

if(NOT SPHINX_BUILD)
  set(SPHINX_BUILD "sphinx-build")
endif()

set(SPHINX_FLAGS "" CACHE STRING "Flags to pass to sphinx-build")
separate_arguments(sphinx_flags UNIX_COMMAND "${SPHINX_FLAGS}")

set(doc_path "${CMAKE_CURRENT_SOURCE_DIR}")

# Configures conf.py in the current folder and puts it in the build folder
configure_file(conf.py conf.py @ONLY)

# We want to run `sphinx-build` with the following builders
set(doc_builders "html" "man")

# Name of all documentation targets
set(doc_targets "")

foreach(builder ${doc_builders})
  set(doc_target "doc_${builder}")
  set(builder_log "builder-${builder}.log")
  add_custom_target(${doc_target}
    COMMAND ${SPHINX_BUILD}
            -b ${builder}
            # conf.py dir
            -c "${CMAKE_CURRENT_BINARY_DIR}"
            -d "${CMAKE_CURRENT_BINARY_DIR}/doctrees"
            ${sphinx_flags}
            # Documentation source file dir
            "${CMAKE_CURRENT_SOURCE_DIR}"
            # Output dir
            "${CMAKE_CURRENT_BINARY_DIR}/${builder}" > ${builder_log}
    COMMENT "sphinx-build ${builder}: see doc/${builder_log}")

  list(APPEND doc_targets ${doc_target})
endforeach()

# Dummy target that depends on all documentation targets
add_custom_target(doc ALL DEPENDS ${doc_targets})

# This is needed for the case where only the doc target is built
# CMAKE_INSTALL_DOCDIR uses PROJECT_NAME which is now polybar-doc, to be
# consistent with a regular install we temporarily override it with "polybar"
# before including GNUInstallDirs
# Also since no language is set and GNUInstallDirs cannot set
# CMAKE_INSTALL_LIBDIR, so we set it to a dummy value to suppress a warning
if(${CMAKE_PROJECT_NAME} STREQUAL "polybar-doc")
  set(PROJECT_NAME "polybar")
  set(CMAKE_INSTALL_LIBDIR "")
  include(GNUInstallDirs)
  set(PROJECT_NAME "polybar-doc")
endif()

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}
  COMPONENT doc)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/man/polybar.1
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
  COMPONENT doc)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/man/polybar.5
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man5
  COMPONENT doc)

=== src/CMakeLists.txt ===
#
# Configure src
#

# Source tree {{{

file(GLOB_RECURSE files RELATIVE ${CMAKE_CURRENT_LIST_DIR} *.c[p]*)
list(REMOVE_ITEM files main.cpp ipc.cpp)

configure_file(
  ${CMAKE_CURRENT_LIST_DIR}/settings.cpp.cmake
  ${CMAKE_BINARY_DIR}/generated-sources/settings.cpp
  ESCAPE_QUOTES)

list(APPEND files ${CMAKE_BINARY_DIR}/generated-sources/settings.cpp)

if(NOT ENABLE_ALSA)
  list(REMOVE_ITEM files modules/alsa.cpp)
  list(REMOVE_ITEM files adapters/alsa/control.cpp)
  list(REMOVE_ITEM files adapters/alsa/mixer.cpp)
endif()
if(NOT ENABLE_CURL)
  list(REMOVE_ITEM files modules/github.cpp)
  list(REMOVE_ITEM files utils/http.cpp)
endif()
if(NOT ENABLE_MPD)
  list(REMOVE_ITEM files modules/mpd.cpp)
  list(REMOVE_ITEM files adapters/mpd.cpp)
endif()
if(NOT ENABLE_NETWORK)
  list(REMOVE_ITEM files modules/network.cpp)
  list(REMOVE_ITEM files adapters/net.cpp)
  list(REMOVE_ITEM files adapters/net_iw.cpp)
  list(REMOVE_ITEM files adapters/net_nl.cpp)
endif()
if(WITH_LIBNL)
  list(REMOVE_ITEM files adapters/net_iw.cpp)
else()
  list(REMOVE_ITEM files adapters/net_nl.cpp)
endif()
if(NOT ENABLE_I3)
  list(REMOVE_ITEM files modules/i3.cpp)
  list(REMOVE_ITEM files utils/i3.cpp)
endif()
if(NOT ENABLE_PULSEAUDIO)
  list(REMOVE_ITEM files modules/pulseaudio.cpp)
  list(REMOVE_ITEM files adapters/pulseaudio.cpp)
endif()
if(NOT WITH_XRANDR)
  list(REMOVE_ITEM files x11/extensions/randr.cpp)
endif()
if(NOT WITH_XCOMPOSITE)
  list(REMOVE_ITEM files x11/extensions/composite.cpp)
endif()
if(NOT WITH_XKB)
  list(REMOVE_ITEM files x11/extensions/xkb.cpp)
  list(REMOVE_ITEM files modules/xkeyboard.cpp)
endif()
if(NOT WITH_XRM)
  list(REMOVE_ITEM files x11/xresources.cpp)
endif()
if(NOT WITH_XCURSOR)
  list(REMOVE_ITEM files x11/cursor.cpp)
endif()
# }}}

# Target: polybar {{{

add_library(poly STATIC ${files})
target_include_directories(poly PUBLIC ${dirs})
target_link_libraries(poly ${libs} Threads::Threads)
target_compile_options(poly PUBLIC $<$<CXX_COMPILER_ID:GNU>:$<$<CONFIG:MinSizeRel>:-flto>>)

add_executable(polybar main.cpp)
target_link_libraries(polybar poly)

install(TARGETS polybar
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT runtime)

# }}}
# Target: polybar-msg {{{

if(BUILD_IPC_MSG)
  add_executable(polybar-msg
    ipc.cpp
    utils/env.cpp
    utils/file.cpp
    utils/string.cpp)
  target_include_directories(polybar-msg PRIVATE ${dirs})
  target_compile_options(polybar-msg PUBLIC $<$<CXX_COMPILER_ID:GNU>:$<$<CONFIG:MinSizeRel>:-flto>>)

  install(TARGETS polybar-msg
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT runtime)

endif()

# }}}

# Export source file list so that it can be used for test compilation
set(files ${files} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
include_directories(${dirs})
include_directories(${CMAKE_CURRENT_LIST_DIR})

# Download and unpack googletest at configure time {{{
configure_file(
  CMakeLists.txt.in
  ${CMAKE_BINARY_DIR}/googletest-download/CMakeLists.txt
  )
execute_process( COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download)

if(result)
  message(FATAL_ERROR "CMake step for googletest failed: ${result}")
endif()

execute_process(COMMAND ${CMAKE_COMMAND} --build .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download )

if(result)
  message(FATAL_ERROR "Build step for googletest failed: ${result}")
endif()

# Add googletest directly to our build. This defines
# the gtest, gtest_main, gmock and gmock_main targets.
add_subdirectory(${CMAKE_BINARY_DIR}/googletest-src
                 ${CMAKE_BINARY_DIR}/googletest-build
                 EXCLUDE_FROM_ALL)

# }}}

# Compile all unit tests with 'make all_unit_tests'
add_custom_target(all_unit_tests
    COMMENT "Building all unit test")

function(add_unit_test source_file)
  string(REPLACE "/" "_" testname ${source_file})
  set(name "unit_test.${testname}")

  add_executable(${name} unit_tests/${source_file}.cpp)

  # Link against gmock (this automatically links against gtest)
  target_link_libraries(${name} poly gmock_main)
  add_test(NAME ${name} COMMAND ${name})

  add_dependencies(all_unit_tests ${name})
endfunction()

add_unit_test(utils/actions)
add_unit_test(utils/color)
add_unit_test(utils/command)
add_unit_test(utils/math unit_tests)
add_unit_test(utils/memory unit_tests)
add_unit_test(utils/scope unit_tests)
add_unit_test(utils/string unit_tests)
add_unit_test(utils/file)
add_unit_test(utils/process)
add_unit_test(components/command_line)
add_unit_test(components/bar)
add_unit_test(components/parser)
add_unit_test(components/config_parser)
add_unit_test(drawtypes/label)
add_unit_test(drawtypes/iconset)

# Run make check to build and run all unit tests
add_custom_target(check
  COMMAND GTEST_COLOR=1 ctest --output-on-failure
  DEPENDS all_unit_tests
  )

=== lib/i3ipcpp/CMakeLists.txt ===
# Project setup

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
project(i3ipc++ CXX)

option(WITH_LOGGING "Build with log support" OFF)
option(WITH_TESTS "Build unit tests executables" OFF)
option(BUILD_EXAMPLES "Build example executables" OFF)

add_library(${PROJECT_NAME} STATIC
  ${PROJECT_SOURCE_DIR}/3rd/auss/include/auss.hpp
  ${PROJECT_SOURCE_DIR}/include/i3ipc++/ipc.hpp
  ${PROJECT_SOURCE_DIR}/include/i3ipc++/ipc-util.hpp
  ${PROJECT_SOURCE_DIR}/src/ipc.cpp
  ${PROJECT_SOURCE_DIR}/src/ipc-util.cpp)

target_include_directories(${PROJECT_NAME} PUBLIC ${PROJECT_SOURCE_DIR}/3rd/auss/include)
target_include_directories(${PROJECT_NAME} PUBLIC ${PROJECT_SOURCE_DIR}/include)

target_compile_options(${PROJECT_NAME} PRIVATE -std=c++11 -Wall -Wextra -Wno-unused-parameter -Wno-deprecated-declarations)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Debug>:-g3 -DDEBUG>)
target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Release>:-O2>)

# External library: jsoncpp-1.7.7 {{{

find_package(PkgConfig)
pkg_check_modules(JSONCPP REQUIRED jsoncpp)

target_link_libraries(${PROJECT_NAME} PUBLIC ${JSONCPP_LIBRARIES})
target_include_directories(${PROJECT_NAME} PUBLIC ${JSONCPP_INCLUDEDIR})

# }}}
# Export lists to the parent scope if there are any {{{

get_directory_property(HAS_PARENT PARENT_DIRECTORY)
if(HAS_PARENT)
  set(I3IPCPP_LIBRARIES ${PROJECT_NAME} PARENT_SCOPE)
  set(I3IPCPP_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/include ${JSONCPP_INCLUDEDIR} PARENT_SCOPE)
endif()

# }}}
# Build examples if the option was given {{{

if(BUILD_EXAMPLES)
  add_subdirectory("${PROJECT_SOURCE_DIR}/examples")
endif()

# }}}
# Build cpp tests if the option was given {{{

if(WITH_TESTS)
  find_package(CxxTest)
  if(CXXTEST_FOUND)
    include_directories(${CXXTEST_INCLUDE_DIR} "${PROJECT_SOURCE_DIR}/src")
    add_definitions("-DTEST_SRC_ROOT=${PROJECT_SOURCE_DIR}/test")
    enable_testing()
    file(GLOB SRC_TEST "${PROJECT_SOURCE_DIR}/test/*.hpp")
    CXXTEST_ADD_TEST(i3ipcpp_check test.cpp ${SRC_TEST})
    target_link_libraries(i3ipcpp_check ${I3IPCPP_LIBRARIES})
  else()
    message(WARNING "CxxTest not found. Unable to run unit-tests")
  endif()
endif()

# }}}

=== debian/changelog ===
polybar (3.5.7-1~mx19+1) mx; urgency=medium

  * Rebuild for MX 19.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 14 Jan 2022 14:57:06 -0800

polybar (3.5.7-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sat, 09 Oct 2021 23:58:59 -0400

polybar (3.5.7-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Samuel Henrique <samueloph@debian.org>  Sun, 03 Oct 2021 22:32:14 +0100

polybar (3.5.7-1) unstable; urgency=medium

  * New upstream version 3.5.7
  * Bump Standards-Version to 4.6.0

 -- Samuel Henrique <samueloph@debian.org>  Fri, 24 Sep 2021 20:11:29 +0100

polybar (3.5.6-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Samuel Henrique <samueloph@debian.org>  Sun, 12 Sep 2021 13:26:55 +0100

polybar (3.5.6-1) unstable; urgency=medium

  * New upstream version 3.5.6

 -- Samuel Henrique <samueloph@debian.org>  Sat, 14 Aug 2021 18:20:54 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Homepage: https://polybar.github.io/
 Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Samuel Henrique <samueloph@debian.org>
+XSBC-Original-Original-Maintainer: Samuel Henrique <samueloph@debian.org>
 Uploaders: Utkarsh Gupta <utkarsh@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 12),
@@ -31,7 +31,7 @@
                python3-sphinx,
                python3-xcbgen,
                xcb-proto
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/polybar
 Vcs-Git: https://salsa.debian.org/debian/polybar.git

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,9 @@
 
 %:
 	dh $@ --buildsystem=cmake --builddirectory=build
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
 
 override_dh_auto_configure:
 	dh_auto_configure --		   \
@@ -23,6 +26,3 @@
 
 override_dh_compress:
 	dh_compress --exclude=config
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## polybar 3.6.3

=== CMakeLists.txt ===
#
# Build configuration
#
cmake_minimum_required(VERSION 3.5.0 FATAL_ERROR)
project(polybar CXX)

# Extract version information from version.txt. The first line that looks like
# a version string is used, so the file supports comments
file(STRINGS version.txt version_txt REGEX "^[0-9]+\\.[0-9]+\\.[0-9]+.*$" LIMIT_COUNT 1)

# If we are in a git repo we can get the version information from git describe
execute_process(COMMAND git describe --tags --dirty=-dev
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  RESULT_VARIABLE git_result
  OUTPUT_VARIABLE git_describe
  OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_QUIET)

if(git_result EQUAL "0")
  set(APP_VERSION "${git_describe}")
else()
  message(STATUS "Could not detect version with git, falling back to built-in version information.")
  set(APP_VERSION "${version_txt}")
endif()

list(APPEND CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/common
  ${PROJECT_SOURCE_DIR}/cmake/modules)

include(GNUInstallDirs)
include(utils)
include(01-core)
include(02-opts)
include(04-targets)

if(BUILD_DOC)
  add_subdirectory(doc)
endif()

if (BUILD_SHELL)
  add_subdirectory(contrib/bash)
  add_subdirectory(contrib/zsh)
endif()

# Setup everything that uses a C++ compiler (polybar, polybar-msg, tests)
if(HAS_CXX_COMPILATION)
  include(cxx)
  if(BUILD_LIBPOLY)
    include(libpoly)
    add_subdirectory(lib)
  endif()
  add_subdirectory(include)
  add_subdirectory(src bin)
endif()

# We need to enable testing in the root folder so that 'ctest' and 'make test'
# can be run in the build directory
if(BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()


if(BUILD_CONFIG)
  install(FILES ${CMAKE_SOURCE_DIR}/doc/config.ini
    DESTINATION /etc/${PROJECT_NAME}
    COMPONENT config)
endif()

include(05-summary)

=== doc/CMakeLists.txt ===
set(SPHINX_BUILD "sphinx-build" CACHE STRING "Name/Path of the sphinx-build executable to use.")
set(SPHINX_FLAGS "" CACHE STRING "Flags to pass to sphinx-build")

find_program(BIN_SPHINX "${SPHINX_BUILD}")

if(NOT BIN_SPHINX)
  message(FATAL_ERROR "sphinx-build executable '${SPHINX_BUILD}' not found.")
endif()

separate_arguments(sphinx_flags UNIX_COMMAND "${SPHINX_FLAGS}")

set(doc_path "${CMAKE_CURRENT_SOURCE_DIR}")

# Configures conf.py in the current folder and puts it in the build folder
configure_file(conf.py conf.py @ONLY)

# We want to run `sphinx-build` with the following builders
if (BUILD_DOC_HTML)
  list(APPEND doc_builders "html")
endif()

if (BUILD_DOC_MAN)
  list(APPEND doc_builders "man")
endif()

# Name of all documentation targets
set(doc_targets "")

foreach(builder ${doc_builders})
  set(doc_target "doc_${builder}")
  set(builder_log "builder-${builder}.log")
  add_custom_target(${doc_target}
    COMMAND ${BIN_SPHINX}
            -b ${builder}
            # conf.py dir
            -c "${CMAKE_CURRENT_BINARY_DIR}"
            -d "${CMAKE_CURRENT_BINARY_DIR}/doctrees"
            -n
            ${sphinx_flags}
            # Documentation source file dir
            "${CMAKE_CURRENT_SOURCE_DIR}"
            # Output dir
            "${CMAKE_CURRENT_BINARY_DIR}/${builder}" > ${builder_log}
    COMMENT "sphinx-build ${builder}: see doc/${builder_log}")

  list(APPEND doc_targets ${doc_target})
endforeach()

# Dummy target that depends on all documentation targets
add_custom_target(doc ALL DEPENDS ${doc_targets})

if (BUILD_DOC_HTML)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}
  COMPONENT doc
  PATTERN ".buildinfo" EXCLUDE)
endif()

install(FILES ${CMAKE_SOURCE_DIR}/CHANGELOG.md
  DESTINATION ${CMAKE_INSTALL_DOCDIR}
  COMPONENT doc)

install(FILES ${CMAKE_CURRENT_LIST_DIR}/config.ini
  DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples
  COMPONENT doc)

if (BUILD_DOC_MAN)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/man/polybar.1
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
  COMPONENT doc)

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/man/polybar-msg.1
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
  COMPONENT doc)

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/man/polybar.5
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man5
  COMPONENT doc)
endif()

=== include/CMakeLists.txt ===
#
# Generate settings.hpp
#

list(APPEND XPP_EXTENSION_LIST xpp::randr::extension)
list(APPEND XPP_EXTENSION_LIST xpp::composite::extension)
if(WITH_XKB)
  list(APPEND XPP_EXTENSION_LIST xpp::xkb::extension)
endif()
string(REPLACE ";" ", " XPP_EXTENSION_LIST "${XPP_EXTENSION_LIST}")

configure_file(
  ${CMAKE_CURRENT_LIST_DIR}/settings.hpp.cmake
  ${CMAKE_BINARY_DIR}/generated-sources/settings.hpp
  ESCAPE_QUOTES)

=== src/CMakeLists.txt ===
#
# Configure src
#

get_include_dirs(includes_dir)
get_sources_dirs(src_dir)

# Source tree {{{

set(ALSA_SOURCES
  ${src_dir}/adapters/alsa/control.cpp
  ${src_dir}/adapters/alsa/mixer.cpp
  ${src_dir}/modules/alsa.cpp
  )

set(GITHUB_SOURCES ${src_dir}/modules/github.cpp ${src_dir}/utils/http.cpp)

set(I3_SOURCES
  ${src_dir}/modules/i3.cpp
  ${src_dir}/utils/i3.cpp
  )

set(MPD_SOURCES
  ${src_dir}/adapters/mpd.cpp
  ${src_dir}/modules/mpd.cpp
  )

set(NETWORK_SOURCES
  ${src_dir}/adapters/net.cpp
  ${src_dir}/modules/network.cpp
  $<IF:$<BOOL:${WITH_LIBNL}>,${src_dir}/adapters/net_nl.cpp,${src_dir}/adapters/net_iw.cpp>
  )

set(PULSEAUDIO_SOURCES
  ${src_dir}/adapters/pulseaudio.cpp
  ${src_dir}/modules/pulseaudio.cpp
  )

set(XCURSOR_SOURCES ${src_dir}/x11/cursor.cpp)

set(XKB_SOURCES
  ${src_dir}/modules/xkeyboard.cpp
  ${src_dir}/x11/extensions/xkb.cpp
  )

set(XRM_SOURCES ${src_dir}/x11/xresources.cpp)

configure_file(
  ${CMAKE_CURRENT_LIST_DIR}/settings.cpp.cmake
  ${CMAKE_BINARY_DIR}/generated-sources/settings.cpp
  ESCAPE_QUOTES)

set(POLY_SOURCES
  ${CMAKE_BINARY_DIR}/generated-sources/settings.cpp

  ${src_dir}/adapters/script_runner.cpp

  ${src_dir}/cairo/utils.cpp

  ${src_dir}/components/bar.cpp
  ${src_dir}/components/builder.cpp
  ${src_dir}/components/command_line.cpp
  ${src_dir}/components/config.cpp
  ${src_dir}/components/config_parser.cpp
  ${src_dir}/components/controller.cpp
  ${src_dir}/components/logger.cpp
  ${src_dir}/components/renderer.cpp
  ${src_dir}/components/screen.cpp
  ${src_dir}/components/eventloop.cpp

  ${src_dir}/drawtypes/animation.cpp
  ${src_dir}/drawtypes/iconset.cpp
  ${src_dir}/drawtypes/layouticonset.cpp
  ${src_dir}/drawtypes/label.cpp
  ${src_dir}/drawtypes/progressbar.cpp
  ${src_dir}/drawtypes/ramp.cpp

  ${src_dir}/events/signal_emitter.cpp
  ${src_dir}/events/signal_receiver.cpp

  ${src_dir}/ipc/ipc.cpp
  ${src_dir}/ipc/decoder.cpp
  ${src_dir}/ipc/encoder.cpp
  ${src_dir}/ipc/util.cpp

  ${src_dir}/modules/backlight.cpp
  ${src_dir}/modules/battery.cpp
  ${src_dir}/modules/bspwm.cpp
  ${src_dir}/modules/counter.cpp
  ${src_dir}/modules/cpu.cpp
  ${src_dir}/modules/date.cpp
  ${src_dir}/modules/fs.cpp
  ${src_dir}/modules/ipc.cpp
  ${src_dir}/modules/memory.cpp
  ${src_dir}/modules/menu.cpp
  ${src_dir}/modules/meta/base.cpp
  ${src_dir}/modules/script.cpp
  ${src_dir}/modules/systray.cpp
  ${src_dir}/modules/temperature.cpp
  ${src_dir}/modules/text.cpp
  ${src_dir}/modules/xbacklight.cpp
  ${src_dir}/modules/xwindow.cpp
  ${src_dir}/modules/xworkspaces.cpp

  ${src_dir}/tags/action_context.cpp
  ${src_dir}/tags/context.cpp
  ${src_dir}/tags/dispatch.cpp
  ${src_dir}/tags/parser.cpp

  ${src_dir}/utils/actions.cpp
  ${src_dir}/utils/action_router.cpp
  ${src_dir}/utils/bspwm.cpp
  ${src_dir}/utils/color.cpp
  ${src_dir}/utils/command.cpp
  ${src_dir}/utils/concurrency.cpp
  ${src_dir}/utils/env.cpp
  ${src_dir}/utils/factory.cpp
  ${src_dir}/utils/file.cpp
  ${src_dir}/utils/inotify.cpp
  ${src_dir}/utils/io.cpp
  ${src_dir}/utils/process.cpp
  ${src_dir}/utils/socket.cpp
  ${src_dir}/utils/string.cpp
  ${src_dir}/utils/units.cpp

  ${src_dir}/x11/atoms.cpp
  ${src_dir}/x11/background_manager.cpp
  ${src_dir}/x11/connection.cpp
  ${src_dir}/x11/ewmh.cpp
  ${src_dir}/x11/extensions/composite.cpp
  ${src_dir}/x11/extensions/randr.cpp
  ${src_dir}/x11/icccm.cpp
  ${src_dir}/x11/registry.cpp
  ${src_dir}/x11/tray_client.cpp
  ${src_dir}/x11/tray_manager.cpp
  ${src_dir}/x11/window.cpp
  ${src_dir}/x11/winspec.cpp
  ${src_dir}/x11/xembed.cpp

  $<$<BOOL:${ENABLE_ALSA}>:${ALSA_SOURCES}>
  $<$<BOOL:${ENABLE_CURL}>:${GITHUB_SOURCES}>
  $<$<BOOL:${ENABLE_I3}>:${I3_SOURCES}>
  $<$<BOOL:${ENABLE_MPD}>:${MPD_SOURCES}>
  $<$<BOOL:${ENABLE_NETWORK}>:${NETWORK_SOURCES}>
  $<$<BOOL:${ENABLE_PULSEAUDIO}>:${PULSEAUDIO_SOURCES}>
  $<$<BOOL:${WITH_XCURSOR}>:${XCURSOR_SOURCES}>
  $<$<BOOL:${WITH_XKB}>:${XKB_SOURCES}>
  $<$<BOOL:${WITH_XRM}>:${XRM_SOURCES}>
  )

# }}}

# Target poly {{{
add_library(poly STATIC EXCLUDE_FROM_ALL ${POLY_SOURCES})
target_include_directories(poly PUBLIC ${includes_dir})
target_link_libraries(poly PUBLIC
  Threads::Threads
  Cairo::CairoFC
  xpp
  LibUV::LibUV
  )

if (TARGET i3ipc++)
  target_link_libraries(poly PUBLIC i3ipc++)
endif()

if (TARGET ALSA::ALSA)
  target_link_libraries(poly PUBLIC ALSA::ALSA)
endif()

if (TARGET CURL::libcurl)
  target_link_libraries(poly PUBLIC CURL::libcurl)
endif()

if (TARGET LibMPDClient::LibMPDClient)
  target_link_libraries(poly PUBLIC LibMPDClient::LibMPDClient)
endif()

if (TARGET LibNlGenl3::LibNlGenl3)
  target_link_libraries(poly PUBLIC LibNlGenl3::LibNlGenl3)
endif()

if (TARGET Libiw::Libiw)
  target_link_libraries(poly PUBLIC Libiw::Libiw)
endif()

if (TARGET LibPulse::LibPulse)
  target_link_libraries(poly PUBLIC LibPulse::LibPulse)
endif()

if (TARGET Xcb::RANDR)
  target_link_libraries(poly PUBLIC Xcb::RANDR)
endif()

if (TARGET Xcb::COMPOSITE)
  target_link_libraries(poly PUBLIC Xcb::COMPOSITE)
endif()

if (TARGET Xcb::XKB)
  target_link_libraries(poly PUBLIC Xcb::XKB)
endif()

if (TARGET Xcb::CURSOR)
  target_link_libraries(poly PUBLIC Xcb::CURSOR)
endif()

if (TARGET Xcb::XRM)
  target_link_libraries(poly PUBLIC Xcb::XRM)
endif()

if (TARGET LibInotify::LibInotify)
  target_link_libraries(poly PUBLIC LibInotify::LibInotify)
endif()

target_compile_options(poly PUBLIC ${cxx_flags})
set_target_properties(poly PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/libs)
# }}}

# Target: polybar {{{
if(BUILD_POLYBAR)
  add_executable(polybar main.cpp)
  target_link_libraries(polybar poly)
  target_compile_options(polybar PUBLIC ${cxx_flags})
  set_target_properties(polybar PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

  install(TARGETS polybar
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT runtime)
endif()
# }}}

# Target: polybar-msg {{{
if(BUILD_POLYBAR_MSG)
  add_executable(polybar-msg polybar-msg.cpp)
  target_link_libraries(polybar-msg poly)
  target_include_directories(polybar-msg PRIVATE ${includes_dir})
  target_compile_options(polybar-msg PUBLIC ${cxx_flags})

  install(TARGETS polybar-msg
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT runtime)
endif()
# }}}

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,3 @@
-include_directories(${dirs})
-include_directories(${CMAKE_CURRENT_LIST_DIR})
-
 # Download and unpack googletest at configure time {{{
 configure_file(
   CMakeLists.txt.in
@@ -39,6 +36,8 @@
   set(name "unit_test.${testname}")
 
   add_executable(${name} unit_tests/${source_file}.cpp)
+  get_include_dirs(includes_dir)
+  target_include_directories(${name} PRIVATE ${includes_dir} ${CMAKE_CURRENT_LIST_DIR})
 
   # Link against gmock (this automatically links against gtest)
   target_link_libraries(${name} poly gmock_main)
@@ -48,20 +47,30 @@
 endfunction()
 
 add_unit_test(utils/actions)
+add_unit_test(utils/action_router)
 add_unit_test(utils/color)
 add_unit_test(utils/command)
-add_unit_test(utils/math unit_tests)
-add_unit_test(utils/memory unit_tests)
-add_unit_test(utils/scope unit_tests)
-add_unit_test(utils/string unit_tests)
+add_unit_test(utils/env)
+add_unit_test(utils/math)
+add_unit_test(utils/memory)
+add_unit_test(utils/scope)
+add_unit_test(utils/string)
 add_unit_test(utils/file)
 add_unit_test(utils/process)
+add_unit_test(utils/units)
+add_unit_test(components/builder)
 add_unit_test(components/command_line)
-add_unit_test(components/bar)
-add_unit_test(components/parser)
 add_unit_test(components/config_parser)
 add_unit_test(drawtypes/label)
+add_unit_test(drawtypes/ramp)
 add_unit_test(drawtypes/iconset)
+add_unit_test(drawtypes/layouticonset)
+add_unit_test(ipc/decoder)
+add_unit_test(ipc/encoder)
+add_unit_test(ipc/util)
+add_unit_test(tags/parser)
+add_unit_test(tags/dispatch)
+add_unit_test(tags/action_context)
 
 # Run make check to build and run all unit tests
 add_custom_target(check

=== lib/xpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.5.0 FATAL_ERROR)
 project(xpp)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
@@ -111,32 +111,32 @@
     "xvmc")
 endif()
 
-if(";${XCB_PROTOS};" MATCHES ";randr;")
+if("randr" IN_LIST XCB_PROTOS)
   find_package(XCB REQUIRED RANDR)
   set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_RANDR_INCLUDE_DIR})
   set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_RANDR_LIBRARY})
 endif()
-if(";${XCB_PROTOS};" MATCHES ";render;")
+if("render" IN_LIST XCB_PROTOS)
   find_package(XCB REQUIRED RENDER)
   set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_RENDER_INCLUDE_DIR})
   set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_RENDER_LIBRARY})
 endif()
-if(";${XCB_PROTOS};" MATCHES ";damage;")
+if("damage" IN_LIST XCB_PROTOS)
   find_package(XCB REQUIRED DAMAGE)
   set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_DAMAGE_INCLUDE_DIR})
   set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_DAMAGE_LIBRARY})
 endif()
-if(";${XCB_PROTOS};" MATCHES ";sync;")
+if("sync" IN_LIST XCB_PROTOS)
   find_package(XCB REQUIRED SYNC)
   set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_SYNC_INCLUDE_DIR})
   set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_SYNC_LIBRARY})
 endif()
-if(";${XCB_PROTOS};" MATCHES ";composite;")
+if("composite" IN_LIST XCB_PROTOS)
   find_package(XCB REQUIRED COMPOSITE)
   set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_COMPOSITE_INCLUDE_DIR})
   set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_COMPOSITE_LIBRARY})
 endif()
-if(";${XCB_PROTOS};" MATCHES ";xkb;")
+if("xkb" IN_LIST XCB_PROTOS)
   find_package(XCB REQUIRED XKB)
   set(XPP_INCLUDE_DIRS ${XPP_INCLUDE_DIRS} ${XCB_XKB_INCLUDE_DIR})
   set(XPP_LIBRARIES ${XPP_LIBRARIES} ${XCB_XKB_LIBRARY})
@@ -151,7 +151,7 @@
 #
 foreach(PROTO_RAW ${PROTO_LIST_RAW})
   string(REGEX REPLACE "(^xf86vidmode.xml|^ge.xml|.xml)\$" "" PROTO ${PROTO_RAW})
-  if(PROTO AND ";${XCB_PROTOS};" MATCHES ";${PROTO};")
+  if(PROTO AND "${PROTO}" IN_LIST XCB_PROTOS)
     message(STATUS "${PROJECT_NAME}: including xcb proto ${PROTO_RAW}")
     set(PROTO_LIST ${PROTO_LIST} ${PROTO})
   endif()
@@ -185,7 +185,7 @@
 target_compile_options(${PROJECT_NAME} PRIVATE -std=c++14 -Wall -Wpedantic)
 target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Debug>:-g3 -DDEBUG>)
 target_compile_options(${PROJECT_NAME} PRIVATE $<$<CONFIG:Release>:-O3 -Wno-unused-variable>)
-target_compile_options(${PROJECT_NAME} PUBLIC ${X11_XCB_DEFINITIONS} ${XCB_DEFINITIONS})
+target_compile_options(${PROJECT_NAME} PUBLIC ${XCB_DEFINITIONS})
 
 set_target_properties(${PROJECT_NAME} PROPERTIES LINKER_LANGUAGE CXX)

=== debian/changelog ===
polybar (3.6.3-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 21 May 2022 15:14:45 -0700

polybar (3.6.3-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Samuel Henrique <samueloph@debian.org>  Fri, 13 May 2022 19:08:08 +0100

polybar (3.6.3-1) unstable; urgency=medium

  * New upstream version 3.6.3

 -- Samuel Henrique <samueloph@debian.org>  Fri, 06 May 2022 17:32:25 +0100

polybar (3.6.2-1) unstable; urgency=medium

  * New upstream version 3.6.2

 -- Samuel Henrique <samueloph@debian.org>  Sun, 03 Apr 2022 19:50:25 +0100

polybar (3.6.1-1) unstable; urgency=medium

  * New upstream version 3.6.1
  * Remove patches applied upstream

 -- Samuel Henrique <samueloph@debian.org>  Sat, 05 Mar 2022 19:26:21 +0000

polybar (3.6.0-3) unstable; urgency=medium

  * d/p/fix_ldflags_override.patch: New upstream patch to fix ldflags override
    and hopefully a FTBFS on mipsel and armel

 -- Samuel Henrique <samueloph@debian.org>  Fri, 04 Mar 2022 19:39:01 +0000

polybar (3.6.0-2) unstable; urgency=medium

  * d/p/fix_missing_includes.patch: New upstream patch to fix FTBFS

 -- Samuel Henrique <samueloph@debian.org>  Wed, 02 Mar 2022 21:38:12 +0000

polybar (3.6.0-1) unstable; urgency=medium

  * New upstream version 3.6.0
  * Remove unneeded patches in favor of config flags
  * d/control: Add new B-D libuv1-dev
  * d/p/fix_doc_flags.patch: New patch to allow skipping installation of docs
  * d/polybar.install: Remove file, upstream now installs config example
  * d/copyright: Update file
  * d/salsa-ci.yml: Remove file in favor of configuring salsa by pointing to
    salsa-ci project instead of file

 -- Samuel Henrique <samueloph@debian.org>  Tue, 01 Mar 2022 22:20:40 +0000

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Homepage: https://polybar.github.io/
 Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Original-Maintainer: Samuel Henrique <samueloph@debian.org>
+XSBC-Original-Maintainer: Samuel Henrique <samueloph@debian.org>
 Uploaders: Utkarsh Gupta <utkarsh@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                i3-wm,
                libasound2-dev,
                libcairo2-dev,
@@ -15,6 +15,7 @@
                libmpdclient-dev,
                libnl-genl-3-dev,
                libpulse-dev,
+               libuv1-dev,
                libxcb-composite0-dev,
                libxcb-cursor-dev,
                libxcb-damage0-dev,

=== debian/rules ===
--- 
+++ 
@@ -9,13 +9,12 @@
 %:
 	dh $@ --buildsystem=cmake --builddirectory=build
 
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-
 override_dh_auto_configure:
-	dh_auto_configure --		   \
+	dh_auto_configure --		       \
 	  -DBUILD_DOC:BOOL="ON"            \
-	  -DBUILD_TESTS:BOOL="OFF"          \
+	  -DBUILD_TESTS:BOOL="OFF"         \
+	  -DBUILD_DOC_HTML:BOOL="OFF"      \
+	  -DBUILD_CONFIG:BOOL="ON"      \
 	  -DENABLE_ALSA:BOOL="ON"          \
 	  -DENABLE_PULSEAUDIO:BOOL="ON"    \
 	  -DENABLE_I3:BOOL="ON"            \
@@ -26,3 +25,6 @@
 
 override_dh_compress:
 	dh_compress --exclude=config
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
